##############################################################################
#
# Copyright (c) 2008-2009 SIA "KN dati". (http://kndati.lv) All Rights Reserved.
#                    General contacts <info@kndati.lv>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import fields,osv
import tools
from mx.DateTime import RelativeDateTime, now, DateTime, localtime

def _lang_get(self, cr, uid, context={}):
	obj = self.pool.get('res.lang')
	ids = obj.search(cr, uid, [])
	res = obj.read(cr, uid, ids, ['code', 'name'], context)
	res = [(r['code'], r['name']) for r in res]
	return res + [(False, '')]

class hardware(osv.osv):
	_name = "it.hardware"
	_rec_name = "name"

	def _get_user(self, cr, uid, ids, field, arg=None, context={}):
		res = {}
		for r in self.browse(cr, uid, ids, context):
			if r.users_id:
				res[r.id] = map(int, r.users_id)[0]
			else:
				res[r.id] = False
		return res

	_columns = {
		'name': fields.char('Name', size=100, required=True),
		'model': fields.char('Model', size=32),
		'model_no': fields.char('Model number', size=32),
		'ref_id': fields.char('Number ID', size=32),
		'serial_no': fields.char('Serial', size=32),
		'is_virtual': fields.boolean('Virtual device'),
		'resource_id': fields.one2many('it.resource', 'hardware_id', 'Resources'),
		'resp_admin': fields.many2many('res.partner.address', 'it_resp_admin_rel', 'hw_id', 'resp_admin_id', 'Responsible admin'),
		'location': fields.many2one('res.partner.address', 'Location', required=True),
		'conn_hardware': fields.many2many('it.hardware', 'it_connhw_rel', 'hw_id', 'con_hw_id', 'Connected hardware'),
		'specification': fields.binary('Specification'),
		'category': fields.many2many('it.hardware.category', 'it_hardware_category_rel', 'hardware_id', 'category_id', 'Categories'),
		'owned_by': fields.many2one('res.partner', 'Owner', required=True),
		'url_id': fields.many2many('it.url', 'it_hardware_url_rel', 'hardware_id', 'url_id', 'Websites'),
		'brand_id': fields.many2one('it.brand', 'Brand'),
		'users_id': fields.many2many('it.users', 'it_hardware_users_rel', 'hardware_id', 'user_id', 'Users'),
		'user_id': fields.function(_get_user, method=True, string='User', type='many2one', obj="it.users"),
		'warr_till': fields.date('Warranty date'),
		'warr_serv': fields.many2many('res.partner.address', 'it_hardware_warr_rel', 'hardware_id', 'contact_id', 'Warranty service'),
		'resp_mat': fields.many2one('res.partner.address', 'Material responsibility'),
		'acq_id': fields.many2one('it.acquisition', 'Acquisition'),
		'con_ids': fields.one2many('it.res_connect', 'hw1_id', 'Connections'),
		'soft_inst_id': fields.one2many('it.soft_install', 'hardware_id', 'Installed software'),
		'consumable_id': fields.many2many('it.consumables', 'it_hw_consum_rel', 'hardware_id', 'consum_id', 'Consumables'),
		'notes': fields.text('Notes'),
		#'ip_reserve': fields.one2many('it.reserve', 'hw_id', 'IP reserve'),
	}

	def search(self, cr, uid, args, offset=0, limit=None, order=None, context=None, count=False):
		if context is None:
			context = {}

		if args and type(args[0][2])==int:
			if args[0][0]=='network':
				result = []
				network = args[0][2]
				ip_obj = self.pool.get('it.reserve')
				limit1 = None
				ids = super(hardware,self).search(cr, uid, [], offset, limit1, order, context=context, count=count)
				for r in self.browse(cr, uid, ids, context):
					ip_ids = map(int, r.ip_reserve)
					for ip in ip_obj.browse(cr, uid, ip_ids, {}):
						if ip.network_id.id == network:
							result.append(r.id)
							break
				return result
			else:
				return super(hardware,self).search(cr, uid, args, offset, limit, order, context=context, count=count)
		find = {'location':False,'user_id':False}
		pos = 0
		for arg in args:
			if 'location' in arg:
				find['location'] = pos
			if 'user_id' in arg:
				find['user_id'] = pos
			pos += 1
		result = []
		limit1=None
		ids = super(hardware,self).search(cr, uid, [], offset, limit1, order, context=context, count=count)
		if args and type(find['user_id'])!=bool and type(args[-1])!=tuple:
			for h in self.browse(cr, uid, ids, {}):
				users_ids = map(int, h.users_id)
				users_obj = self.pool.get('it.users')
				for r in users_obj.browse(cr, uid, users_ids, {}):
					name = r.name_get(cr, uid, [r.id], {})[0][1]
					if (unicode(name.lower(),"UTF-8")).find(args[find['user_id']][2].lower()) != -1:
						result.append(h.id)
			args[find['user_id']] = ['id', 'in', result]

		result = []
		if args and type(find['location'])!=bool and type(args[-1])!=tuple:
			if type(args[find['location']][2]) == str:
				cr.execute("""
						SELECT id, location
						FROM it_hardware
						WHERE id in (%s)
					   """ % (','.join(map(str,ids))))
				locations = cr.fetchall()
				for id, location in locations:
					name = self.pool.get('res.partner.address').browse(cr, uid, location, {}).name_get(cr, uid, [location], {})[0][1]
					if (unicode(name.lower(), "UTF-8")).find(args[find['location']][2].lower()) != -1:
						result.append(id)
				args[find['location']] = ['id', 'in', result]

		return super(hardware,self).search(cr, uid, args, offset, limit, order, context=context, count=count)

	def name_get(self, cr, user, ids, context={}):
		if not len(ids):
			return []
		res = []
		for r in self.read(cr, user, ids, ['name','ref_id']):
			name = str(r['name'])
			if r['ref_id']:
				name +=', '
				name += str(r['ref_id'])
			res.append((r['id'], name))
		return res

hardware()

class resource_type(osv.osv):
	_name = "it.res_type"
	_rec_name = "name"

	_columns = {
		'name': fields.char('Resource name', size=32, required=True),
		'category' : fields.many2many('it.res_type.category', 'it_res_type_category_rel', 'res_type_id', 'category_id', 'Categories'),
		'warn' : fields.boolean('Warning message'),
	}
	_defaults = {
		'warn' : lambda *a: 1,
	}

resource_type()

class resource(osv.osv):
	_name = "it.resource"
	_rec_name = "hardware_id"

	def _get_owner(self, cr, uid, ids, field, arg=None, context={}):
		res = {}
		obj = self.pool.get('inv.rec_filter_cond')
		connect = self.pool.get('it.res_connect')
		for p in self.browse(cr, uid, ids, context):
			ids = connect.search(cr, uid, [('res1_id', '=', p.id)])
			if ids!=[]:
				res[p.id] = connect.browse(cr, uid, ids[0], {}).hw2_id.owned_by.id
			else:	
				res[p.id] = False
		return res

	def search(self, cr, uid, args, offset=0, limit=None, order=None,
			context=None, count=False):
		if context is None:
			context = {}
		if len(args)<=1:
			return super(resource,self).search(cr, uid, args, offset, limit, order, context=context, count=count)
		search_arg = args[0][2]
		if type(search_arg) != str:
			search_arg = args[1][2]
		ids  = self.search(cr, uid, [])
		if args[0][0] == 'hardware_id' or (len(args) > 1 and args[1][0]) == 'hardware_id':
			res_ids = []
			for r in self.browse(cr, uid , ids, {}):
				if r.hardware_id.ref_id and (r.hardware_id.ref_id).find(search_arg) != -1:
					res_ids.append(r.id)
			if res_ids!=[]:
				if args[0][0] == 'hardware_id':
					args = [['id', 'in', res_ids],args[1]]
				else:
					args = [args[0],['id', 'in', res_ids]]
		return super(resource,self).search(cr, uid, args, offset, limit,
				order, context=context, count=count)

	_columns = {
		'type': fields.many2one('it.res_type', 'Resource type', required=True),
		'hardware_id': fields.many2one('it.hardware', 'Resource', ondelete='cascade', required=True),
		'constraint': fields.integer('Amount'),
		'role': fields.selection((('c','Consumer'), ('p','Provider'), ('u', 'Universal')), 'Role', size=3, required=True),
		'connection': fields.one2many('it.res_connect', 'res1_id', 'Connection'),
		'owner': fields.function(_get_owner, type='many2one', obj="res.partner", method=True, string='Owner'),
	}

	def _constraint1(self, cr, uid, ids):
		cr.execute("""SELECT count(A.id) as Count
	 			FROM it_res_connect A, it_resource B
	 			WHERE A.res1_id = B.id and B.id = """+','.join(map(str,ids)))
		conn_count = cr.fetchone()[0]

		cr.execute("""SELECT A.constraint
	 			FROM it_resource A
	 			WHERE A.id = """+','.join(map(str,ids)))
		count = cr.fetchone()[0]

		if conn_count > count:
			return False

          	return True

	_defaults = {
		'constraint' : lambda *a: 1,
		'role' : lambda *a: 'c',
	}

	_constraints = [
        	(_constraint1, 'Amount of connection is not allowed!', ['Amount'])
    	]

	def name_get(self, cr, user, ids, context={}):
		if not len(ids):
			return []
		res = []
		for r in self.read(cr, user, ids, ['hardware_id', 'role']):
			name = str(r['hardware_id'][1])
			if r['role']:
				name +=', '
				if r['role']=='c':
					name += 'Consumer'
				elif r['role']=='p':
					name += 'Provider'
				elif r['role']=='u':
					name += 'Universal'
			res.append((r['id'], name))
		return res

resource()

class res_connect(osv.osv):
	_name = "it.res_connect"
	_rec_name = "res2_id"

	_columns = {
		'hw1_id': fields.many2one('it.hardware', 'Hardware1'),
		'hw2_id': fields.many2one('it.hardware', 'Hardware2'),
		'res1_id': fields.many2one('it.resource', 'Resource1'),
		'res2_id': fields.many2one('it.resource', 'Resource2', required=True, ondelete='cascade'),#, domain="[('role', '!=', parent.role)]"
		'ref': fields.many2one('it.res_connect', 'Reference', ondelete='cascade'),
	}

	def _constraint1(self, cr, uid, ids):
		cr.execute("""SELECT A.hardware_id
	 			FROM it_resource A, it_res_connect B
	 			WHERE B.res1_id = A.id and B.id = """+','.join(map(str,ids)))
		res1 = cr.fetchone()[0]

		cr.execute("""SELECT A.hardware_id
	 			FROM it_resource A, it_res_connect B
	 			WHERE B.res2_id = A.id and B.id = """+','.join(map(str,ids)))
		res2 = cr.fetchone()[0]

		cr.execute("""UPDATE it_res_connect
			      SET hw1_id=%s,
				  hw2_id=%s
			      WHERE id = """+','.join(map(str,ids)), (res1, res2))
          	return True

	def _constraint2(self, cr, uid, ids):
		cr.execute("""SELECT *
	 			FROM it_res_connect
	 			WHERE id = """+','.join(map(str,ids)))
		record = cr.fetchone()

		if not record[4]:
			cr.execute("select nextval('"+self._sequence+"')")
			id_new = cr.fetchone()[0]

			cr.execute("""INSERT INTO it_res_connect(id,perm_id,create_uid,create_date,write_date,write_uid,hw1_id,res2_id,ref,res1_id,hw2_id)
			      VALUES (%d,%s,%s,%s,%s,%s,%d,%d,%d,%d,%d)""",
			(id_new,record[1],record[2],record[3],record[4],record[5],record[10],record[9],record[0],record[7],record[6]))

		      	cr.execute("""UPDATE it_res_connect 
			      SET id=%d,perm_id=%s,create_uid=%s,create_date=%s,write_date=%s,write_uid=%s,hw1_id=%d,res2_id=%d,ref=%d,res1_id=%d,hw2_id=%d
			      WHERE id = """+','.join(map(str,ids)), (record[0],record[1],record[2],record[3],record[4],record[5],record[6],record[7],id_new,record[9],record[10]))
		return True

	_constraints = [
        	(_constraint1, ''),
		(_constraint2, '')
    	]

	def name_get(self, cr, user, ids, context={}):
		if not len(ids):
			return []
		res = []
		for r in self.read(cr, user, ids, ['hw2_id']):
			res.append((r['id'], r['hw2_id'][1]))
		return res

res_connect()

class all_hw_location(osv.osv):
	_name = "it.all_hw_location"
	_inherit = "res.partner.address"
	_description = "All location of all hardware"
	_auto = False

	_columns = {

	}

	def init(self, cr):
		cr.execute("""
		create or replace view it_all_hw_location as (
			SELECT DISTINCT A.id as id, A.partner_id, A.type, A.name, A.street, A.city, A.country_id, A.email, A.phone, A.active
			FROM res_partner_address A, it_hardware B
			WHERE A.id = B.location
		)""")

all_hw_location()

class all_hw_owners(osv.osv):
	_name = "it.all_hw_owners"
	_inherit = "res.partner"
	_description = "All owners of all hardware"
	_auto = False

	_columns = {
		'name': fields.char('Name', size=128, required=True, select=True, readonly="1"),
		'date': fields.date('Date', readonly=True),
		'ref': fields.char('Code', size=64, readonly=True),
		'lang': fields.selection(_lang_get, 'Language', size=5, readonly="1"),
		'address': fields.one2many('res.partner.address', 'partner_id', 'Contacts', readonly="1"),
		'category_id': fields.many2many('res.partner.category', 'res_partner_category_rel', 'partner_id', 'category_id', 'Categories', readonly="1"),
		'active': fields.boolean('Active', readonly="1"),
	}

	def init(self, cr):
		cr.execute("""
		create or replace view it_all_hw_owners as (
			SELECT DISTINCT A.id as id, A.name, A.date, A.ref, A.lang, A.active
			FROM res_partner A, it_hardware B
			WHERE A.id = B.owned_by
		)""")

all_hw_owners()

class all_res_connections(osv.osv):
	_name = "it.all_res_connections"
	_auto = False

	_columns = {
		'id': fields.integer(),
		'name': fields.char('Name', size=32, required=True),
		'model': fields.char('Model', size=32),
		'ref_id': fields.char('Number ID', size=32),
		'is_virtual': fields.boolean('Virtual device'),
		'location': fields.many2one('res.partner.address', 'Location', required=True),
		'owned_by': fields.many2one('res.partner', 'Owner', required=True),
		'brand_id': fields.many2one('it.brand', 'Brand'),
		'far_ids': fields.char('Far ids', size=100),
	}

	def init(self, cr):
		cr.execute("""
		create or replace view it_all_res_connections as (
			select hwd.id as id,
				hwd.model as model,
				hwd.name as name,
				hwd.location as location,
				hwd.ref_id as ref_id,
				hwd.owned_by as owned_by,
				hwd.brand_id as brand_id,
				hwd.is_virtual as is_virtual,
				'-' || (select array_to_string(
				array(select con.hw1_id from it_res_connect as con where con.hw2_id = hwd.id
			union
			select con.hw2_id from it_res_connect as con where con.hw1_id = hwd.id)
				,'-')) || '-' as far_ids
			from it_hardware as hwd
		)""")

all_res_connections()
